---
title: WebGL2RenderingContext.transformFeedbackVaryings()
slug: Web/API/WebGL2RenderingContext/transformFeedbackVaryings
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.transformFeedbackVaryings()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2 API</a> specifies values to record in {{domxref("WebGLTransformFeedback")}} buffers.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.transformFeedbackVaryings(program, varyings, bufferMode);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>program</dt>
 <dd>A {{domxref("WebGLProgram")}}.</dd>
 <dt>varyings</dt>
 <dd>An {{jsxref("Array")}} of {{domxref("DOMString")}} specifying the names of the varying variables to use.</dd>
 <dt><code>bufferMode</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the mode to use when capturing the varying variables. Either <code>gl.INTERLEAVED_ATTRIBS</code> or <code>gl.SEPARATE_ATTRIBS</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var transformFeedback = gl.createTransformFeedback();
gl.bindTransformFeedback(gl.TRANSFORM_FEEDBACK, transformFeedback);
var transformFeedbackOutputs = ['gl_Position', 'anotherOutput'];

gl.transformFeedbackVaryings(shaderProg, transformFeedbackOutputs,
                             gl.INTERLEAVED_ATTRIBS);
gl.linkProgram(shaderProg);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.15", "transformFeedbackVaryings")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glTransformFeedbackVaryings.xhtml", "glTransformFeedbackVaryings")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.transformFeedbackVaryings")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLTransformFeedback")}}</li>
</ul>
